 /**
 * 
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.*;
import com.yealink.profile.encyption.Yealink;
import java.lang.Thread;
import java.lang.Runnable;
import java.util.Arrays;
  /**
  * @author magc
  *
  */
class MyThead implements Runnable
{
    private final static int BUF_LEN = 4096;
    private final static int OUT_BUF_MAX_SIZE = 4096;
    String srcFilePath;
    String dstFilePath;
    String strkey;
    File srcFile = null;
    File dstFile = null;
    byte inBytes[] = new byte[BUF_LEN];
    Yealink yl_encrypt = new Yealink();

    public MyThead(String sourcFile, String destFile, String key){
        srcFilePath = sourcFile;
        dstFilePath = destFile;
        strkey = key;
        srcFile = new File(srcFilePath);
        dstFile = new File(dstFilePath);
        System.out.println("*java: srcFilePath=" + srcFilePath + ", dstFilePath=" + dstFilePath + ", key=" + strkey);
    }

    public void run()  
    {
        boolean isFileAvailable = isFileAvailable(srcFile, dstFile);
        if (isFileAvailable){
        //while(isFileAvailable){
            try {
                encryptFileTest();
                System.gc();
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private boolean isFileAvailable(File sourceFile, File destFile) {
        if (!sourceFile.exists()) {
            //System.out.println("java: src file(" + srcFilePath + ") don't exsit, please create it first!");
            return false;
        }
        else {
            if (!destFile.exists()) {
                try {
                    if (destFile.createNewFile()) {
                      //System.out.println("java: create" + dstFilePath + "success");
                    } else {
                      //System.out.println("java: create" + dstFilePath + "fail");
                      return false;
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        return true;
    }

    private void encryptFileTest() throws Exception {
        //System.out.println(" ********************** Encrypt start *************************");
        int total = 0;
        int temp = 0;
        int len = 0;
        byte outBytes[] = null;

        InputStream input = new FileInputStream(srcFile);
        OutputStream output = new FileOutputStream(dstFile);

        int ret = yl_encrypt.checkEncryptKeyJni(strkey);
        if (0 != ret)
        {
            //System.out.println("java: aes key error,please use another aes key,ret = " + ret);
        } else {
            //System.out.println("encrypt file is ok ,ret = " + ret);               
        }
        Arrays.fill(inBytes, (byte)0);
        while ((temp = input.read()) != -1) {
            inBytes[len] = (byte)temp;
            len++;
            if ( len >= BUF_LEN ) {
                outBytes = yl_encrypt.EncodeJni(strkey, inBytes, len ,OUT_BUF_MAX_SIZE);
                output.write(outBytes);
                total += outBytes.length;
                len = 0;
                Arrays.fill(inBytes, (byte)0);
            }
        }
        outBytes = yl_encrypt.EncodeJni(strkey, inBytes, len, OUT_BUF_MAX_SIZE);
        output.write(outBytes);
        total += outBytes.length;

        //System.out.println("return encrypt total len = " + total + ",  cur return len = " + outBytes.length + "， key=" + strkey);
        input.close();
        output.close();
        outBytes = null;
        input = null;
        output = null;
    }
}

public class YealinkDemo {
     public static void main(String[] args) throws Exception {

        if (args.length < 3) {
             System.out.println("---- error: Too few parameters!" );
             System.out.println("---- Please do it like :" );
             System.out.println("         java YealinkDemo srcFilePath dstFilePath deskey" );
             System.out.println("---- Before you do it,please make sure your srcFilePath have exist!" );
             return ;
        }
        String srcFilePath = args[0];
        String dstFilePath = args[1];
        String strkey = args[2];
        MyThead myThead = new MyThead(srcFilePath, dstFilePath, strkey);
        Thread thread = new Thread(myThead);
        thread.start();
    }
 }
