

   package com.yealink.profile.encyption;
  /**
  * @author magc
  *
  */
  public class Yealink {
    static {
         System.loadLibrary("yl_encrypt_jni");
    }
    /**
    * @brief :  encrypt data by aes key
    * @param :  strKey           [IN]    aes key
    * @param :  szinBytes        [IN]    plaintext input data
    * @param :  ninSize          [IN]    plaintext input data size,one time max size support 4096
    * @param :  noutSize         [IN]    ciphertext output buffer size,one time max size support 4096
    * @return   byte[]           means   ciphertext data buffer
    *           null             means   fail
    */
     public native byte[] EncodeJni(String strKey, byte szinBytes[] , int ninSize, int noutSize);

    /**
    * @brief :  dencrypt data by aes key
    * @param :  strKey           [IN]    aes key
    * @param :  szinBytes        [IN]    ciphertext input data
    * @param :  ninSize          [IN]    ciphertext input data size,one time max size is 4096
    * @param :  noutSize         [IN]    plaintext output buffer size,one time max size is 4096
    * @return   byte[]           means   plaintext data buffer
    *           null             means   fail
    * @Note : The DeEncodeJni is only valid in DEBUG version
    */
     public native byte[] DeEncodeJni(String strKey, byte szinBytes[] , int ninSize, int noutSize);

    /**
    * @brief :  check aes key by for encrypt file
    * @param :  strKey        [IN]    aes key string
    * @return    0            means   aes key is ok
    * @return   -1            means   aes key error,smust change another one
    */
     public native int checkEncryptKeyJni(String strKey);

     /*
     * @brief  :  Basic64 encrypt/decrypt text
     *
     * @param pszStr_in:    [in]     Content to be encrypted/decrypted
     * @param pszStrLen_in: [in]     The pszStr_in len
     * @param pszStr_out:   [in]     The buf to save ciphertext/plaintext
     * @param pszStrLen_out:[out]    pszStr_out size
     *
     * @return : 0 is success, otherwise failed.
     *
     */
     public native int BASE64_EncryptJni(String pszStIin, int pszStrLenIn, String pszStrOut, int pszStrLenOut);
     public native int BASE64_DecryptJni(String pszStIin, int pszStrLenIn, String pszStrOut, int pszStrLenOut);

     /*
     * @brief  :  RSA encrypt text
     *
     * @param pszPubKey:    [in]     The RSA pubilc key file
     * @param pszStr_in:    [in]     Content to be encrypted
     * @param pszStrLen_in: [in]     The pszStr_in len
     * @param pszStr_out:   [in]     The buf to save ciphertext
     * @param pszStrLen_out:[out]    pszStr_out size
     *
     * @return : 0 is success, otherwise failed.
     *
     */
     public native int RSA_EncryptJni(String pszPubKey, String pszStIin, int pszStrLenIn, String pszStrOut, int pszStrLenOut);

     /*
     * @brief  :  RSA encrypt text
     *
     * @param pszPubKey:    [in]     The RSA pubilc key file
     * @param pszAesKey:    [in]     secret key
     * @param pszCfgIn:     [in]     Files requiring encryption
     * @param pszCfgOut:    [in]     Encrypted File Storage Path
     *
     * @return : 0 is success, otherwise failed.
     *
     */
     public native int RSA_ConfigJni(String pszPubKey, String pszAesKey, String pszCfgIn, String pszCfgOut);
     public native int CMPT_ConfigJni(String pszPubKey, String pszAesKey, String pszCfgIn, String pszCfgOut);

 }
